using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;


namespace VamSander {


public class Draggable : MVRScript, IPointerUpHandler, IPointerDownHandler //, IPointerEnterHandler, IDragHandler
{
    private Vector3 offset;
    private Vector3 pos;
    private float zdist;
    private bool isLeftHand = true;
    private bool isPointerDown = false;
    private bool isFirstRun = true;
    private Transform tempParent;

    public 	Transform controllerTransform; 

    void FixedUpdate()
    {
        if(isPointerDown)
        {
            if (isFirstRun)
            {
                if (!SuperController.singleton.isOVR && !SuperController.singleton.isOpenVR)
                {
                    zdist = Camera.main.transform.position.z - controllerTransform.position.z; 
                }
                else
                {
                    tempParent = controllerTransform.parent;

                    if (isLeftHand)
                    { 
                            controllerTransform.SetParent(SuperController.singleton.leftHand);                
                    }
                    else
                    {
                            controllerTransform.SetParent(SuperController.singleton.rightHand);                        
                    }
                }
                isFirstRun = false;
            }
            else
            {
                if (!SuperController.singleton.isOVR && !SuperController.singleton.isOpenVR)
                {
                    pos = new Vector3(Input.mousePosition.x, Input.mousePosition.y, zdist);
                    offset = Camera.main.ScreenToWorldPoint(pos);
                    controllerTransform.position = offset;
                }
            }
        }
    }

    public void OnPointerDown(PointerEventData eventData)
    {   
        if (SuperController.singleton.isOVR || SuperController.singleton.isOpenVR)
        {   
            float dist;
            Vector3 LeftPos = new Vector3(SuperController.singleton.leftHand.position.x, SuperController.singleton.leftHand.position.y, SuperController.singleton.leftHand.position.z );
            Vector3 RightPos = new Vector3(SuperController.singleton.rightHand.position.x, SuperController.singleton.rightHand.position.y, SuperController.singleton.rightHand.position.z);

            if (SuperController.singleton.isOpenVR)
            {
                dist = eventData.pointerPressRaycast.distance + 0.068475f;  //openvr               
            }
            else
            {
                dist = eventData.pointerPressRaycast.distance + 0.017986f;  //oculus
            }

            float LeftDiff = Mathf.Abs(Vector3.Distance(controllerTransform.position, LeftPos) - dist);
            float RightDiff = Mathf.Abs(Vector3.Distance(controllerTransform.position, RightPos) - dist);
           
            isLeftHand = (LeftDiff < RightDiff);                             
        }

        isPointerDown = true;
    }
    

    public void OnPointerUp(PointerEventData eventData)
    {   
        if (SuperController.singleton.isOVR || SuperController.singleton.isOpenVR)
        {   
            controllerTransform.SetParent(tempParent);
        }

        isFirstRun = true;
        isPointerDown = false;
    }

}

}
